% Ronny Luss and Alexandre d'Aspremont, last modification: March 2008

% Modify paths to libsvm and libsvm matlab interface
addpath('C:\Documents and Settings\rluss\My Documents\Ronny Research\Machine Learning\Indefinte Kernel Algorithm\libsvm-mat-2.88-1');
addpath(genpath(pwd)); % add to path current directory and subdirectories mexFunctions and subRoutines

% parameters
acc=.01;
maxiters=2000;
info=100;
C=10;
rho=10;
stepsize=5; % only for Projected Gradient Algorithm

%%%% Indefinite SVM
load('USPS_simpson_3_5.mat');
numTrain=length(labelsTrain);
% Train using Projected Gradient Algorithm
[alpha,primal,dual,gap]=IndefiniteSVM(K(1:numTrain,1:numTrain),labelsTrain,C,rho,acc,info,maxiters,stepsize,1);
% Test using Results of Projected Gradient Algorithm
[pred,accuracy,recall,precision]=IndSVMerror(alpha,labelsTrain,labelsTest,K,C,rho); % get the error
% Test Analytic Center Cutting Plane Method
[alpha,primal,dual,gap]=IndefiniteSVM(K(1:numTrain,1:numTrain),labelsTrain,C,rho,acc,info,maxiters,[],2);
% Test using Results of ACCPM
[pred,accuracy,recall,precision]=IndSVMerror(alpha,labelsTrain,labelsTest,K,C,rho); % get the error
disp('Done with IndefiniteSVM test.');

%%% Perturb SVM
load('USPS_gauss_3_5.mat');
numTrain=length(labelsTrain);
% Train using Projected Gradient Algorithm
[alpha,primal,dual,gap]=PerturbSVM(K(1:numTrain,1:numTrain),labelsTrain,C,rho,acc,info,maxiters,stepsize,1);
% Test using Results of Projected Gradient Algorithm
[pred,accuracy,recall,precision]=PertSVMerror(alpha,labelsTrain,labelsTest,K,C,rho); % get the error
% Test Analytic Center Cutting Plane Method
[alpha,primal,dual,gap]=PerturbSVM(K(1:numTrain,1:numTrain),labelsTrain,C,rho,acc,info,maxiters,[],2);
% Test using Results of ACCPM
[pred,accuracy,recall,precision]=PertSVMerror(alpha,labelsTrain,labelsTest,K,C,rho); % get the error

disp('Done with PerturbSVM test.');



